/* Tabela RECESERV: Receita por Servio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RECESERV */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Receita por Servio,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_RECESERV
AFTER DELETE OR INSERT OR UPDATE
ON RECESERV FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_CDARVPROD VARCHAR2(20);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDARVPROD := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
      V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI;
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      IF (NVL(:OLD.CDAPRERECE, '') <> '') THEN
         V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE;
      END IF;
      V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODRECSER, 5), '9999999990.00000'));
      IF (NVL(:OLD.SGUNIDADE, '') <> '') THEN
         V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE;
      END IF;
      IF (NVL(:OLD.VRPEFATCOCSE, -1) <> -1) THEN
         V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCSE, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.VRPEFATCORSE, -1) <> -1) THEN
         V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORSE, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.HRTEMPPREPSE, '') <> '') THEN
         V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPSE, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPSE, 4, 5);
      END IF;
      IF (NVL(:OLD.QTBRUTASEUNR, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTASEUNR, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTBRUTASE, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTASE, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.IDPRODBASESE, '') <> '') THEN
         V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASESE;
      END IF;
      IF (NVL(:OLD.VRPEFATNUTSE, -1) <> -1) THEN
         V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTSE, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.QTCALCNUTRSE, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRSE, 5), '9999999990.00000'));
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILIAL||:OLD.CDSERVFILI||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (:OLD.CDFILIAL     <> :NEW.CDFILIAL    ) OR
            (:OLD.CDSERVFILI   <> :NEW.CDSERVFILI  ) OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO   ) OR
            (:OLD.QTPRODRECSER <> :NEW.QTPRODRECSER) OR
            (NVL(:OLD.CDAPRERECE,   '') <> NVL(:NEW.CDAPRERECE,   '')) OR
            (NVL(:OLD.SGUNIDADE,    '') <> NVL(:NEW.SGUNIDADE,    '')) OR
            (NVL(:OLD.HRTEMPPREPSE, '') <> NVL(:NEW.HRTEMPPREPSE, '')) OR
            (NVL(:OLD.IDPRODBASESE, '') <> NVL(:NEW.IDPRODBASESE, '')) OR
            (NVL(:OLD.VRPEFATCOCSE,  -1) <> NVL(:NEW.VRPEFATCOCSE,  -1)) OR
            (NVL(:OLD.VRPEFATCORSE,  -1) <> NVL(:NEW.VRPEFATCORSE,  -1)) OR
            (NVL(:OLD.QTBRUTASEUNR,  -1) <> NVL(:NEW.QTBRUTASEUNR,  -1)) OR
            (NVL(:OLD.QTBRUTASE,     -1) <> NVL(:NEW.QTBRUTASE,     -1)) OR
            (NVL(:OLD.VRPEFATNUTSE,  -1) <> NVL(:NEW.VRPEFATNUTSE,  -1)) OR
            (NVL(:OLD.QTCALCNUTRSE,  -1) <> NVL(:NEW.QTCALCNUTRSE,  -1)) THEN
            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILIAL||:OLD.CDSERVFILI||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDPRATO||:NEW.CDFILAUXPRAT||:NEW.CDFILIAL||:NEW.CDSERVFILI||V_CDARVPROD;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) OR (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO || ' - ';
            ELSE
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ';
            END IF;
            IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
            ELSE
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT;
            END IF; 
         ELSE
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Prato=' || :NEW.CDPRATO || ' - ' || :NEW.CDFILAUXPRAT;
      END IF; 
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDSERVFILI <> :NEW.CDSERVFILI) THEN
            V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI || '|' || :NEW.CDSERVFILI;
         ELSE
            V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Serv=' || :NEW.CDSERVFILI;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO <> :NEW.CDPRODUTO) THEN
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
            V_DESC := V_DESC || '|' || V_CDARVPROD;
         ELSE
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      ELSE
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF (NVL(:NEW.CDAPRERECE, '') <> '') OR (UPDATING AND (NVL(:NEW.CDAPRERECE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDAPRERECE, '') <> NVL(:NEW.CDAPRERECE, '')) THEN
               V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE || '|' || :NEW.CDAPRERECE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Apres=' || :NEW.CDAPRERECE;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.QTPRODRECSER <> :NEW.QTPRODRECSER) THEN
            V_DESC := V_DESC || ' Qtde.=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODRECSER, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODRECSER, 5), '9999999990.00000'));
         END IF;
      ELSE
         V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODRECSER, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:NEW.SGUNIDADE, '') <> '') OR (UPDATING AND (NVL(:NEW.SGUNIDADE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.SGUNIDADE, '') <> NVL(:NEW.SGUNIDADE, '')) THEN
               V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE || '|' || :NEW.SGUNIDADE;
            END IF;
         ELSE 
            V_DESC := V_DESC || ' Un=' || :NEW.SGUNIDADE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCOCSE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCOCSE, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATCOCSE, -1) <> NVL(:NEW.VRPEFATCOCSE, -1)) THEN
               V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCSE, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCSE, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCSE, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCORSE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCORSE, -1) = -1)) THEN
         IF UPDATING THEN
             IF (NVL(:OLD.VRPEFATCORSE, -1) <> NVL(:NEW.VRPEFATCORSE, -1)) THEN  
                V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORSE, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORSE, 5), '9999999990.00'));
             END IF;
         ELSE
            V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORSE, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.HRTEMPPREPSE, '') <> '') OR (UPDATING AND (NVL(:NEW.HRTEMPPREPSE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.HRTEMPPREPSE, '') <> NVL(:NEW.HRTEMPPREPSE, '')) THEN  
               IF (NVL(:OLD.HRTEMPPREPSE, '') = '') THEN
                  V_DESC := V_DESC || ' Temp=' || '|' || SUBSTR(:NEW.HRTEMPPREPSE, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPSE, 4, 5); 
               ELSE
                  V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPSE, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPSE, 4, 5) || '|' || SUBSTR(:NEW.HRTEMPPREPSE, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPSE, 4, 5);
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Temp=' || SUBSTR(:NEW.HRTEMPPREPSE, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPSE, 4, 5);
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTASEUNR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTASEUNR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTASEUNR, -1) <> NVL(:NEW.QTBRUTASEUNR, -1)) THEN  
               V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTASEUNR, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTASEUNR, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTASEUNR, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTASE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTASE, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTASE, -1) <> NVL(:NEW.QTBRUTASE, -1)) THEN  
               V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTASE, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTASE, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTASE, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.IDPRODBASESE, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPRODBASESE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPRODBASESE, '') <> NVL(:NEW.IDPRODBASESE, '')) THEN  
               V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASESE || '|' || :NEW.IDPRODBASESE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PrBase=' || :NEW.IDPRODBASESE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATNUTSE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATNUTSE, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATNUTSE, -1) <> NVL(:NEW.VRPEFATNUTSE, -1)) THEN  
               V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTSE, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTSE, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTSE, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTCALCNUTRSE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCALCNUTRSE, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCALCNUTRSE, -1) <> NVL(:NEW.QTCALCNUTRSE, -1)) THEN
               V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRSE, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRSE, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRSE, 5), '9999999990.00000'));
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('RECESERV', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

